> For the complete documentation index, see [llms.txt](https://developer.singular.live/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.singular.live/rest-api/how-to-guides/update-a-sub-compositions-content.md).

# Update a sub-composition's content

To update a sub-composition's content, you'll need two things:

* The[ app token](https://developer.singular.live/rest-api/how-to-guides/get-a-control-apps-api-token.md) for the particular instance of the control app you're using
* The[ sub-composition's name or ID and its payload structure](https://developer.singular.live/rest-api/how-to-guides/get-a-compositions-sub-composition-ids-and-names-and-their-payload-structures.md)

With that data on hand

1. Prepare a `PATCH` request to `https://app.singular.live/apiv2/controlapps/:appToken/control`, which is the endpoint to [update a control app](https://developer.singular.live/rest-api/api-reference/send-data-to-a-control-app/update-a-control-apps-content.md).
2. Replace `:appToken` with the app token for your app instance.
3. Add a request body with the actual sub-composition ID and payload structure, and include the updates you'd like to make. The request body should look like this, but with sub-composition name or ID and payload data filled in.

{% tabs %}
{% tab title="Sub-composition name" %}

```json
[
    {
        "subCompositionName": "your-subcomposition-name",
        "payload": {
          "controlnode-field": "control node content"
        }
    }
]
```

{% endtab %}

{% tab title="Sub-composition ID" %}

```json
[
    {
        "subCompositionId": "your-subcomposition-id",
        "payload": {
          "controlnode-field": "control node content"
        }
    }
]
```

{% endtab %}
{% endtabs %}

After sending the request, you should get a `200 OK` response with a payload of `{ "success": true }`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.singular.live/rest-api/how-to-guides/update-a-sub-compositions-content.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
